//查找冗余和重复的图片资源

var jsonDir = "./";
fs = require('fs');
util = require('util');

/*
dirState = fs.stat(jsonDir,(err,stats)=>{
    if(err)throw err;
    console.log("isDirectory:" + stats.isDirectory());

    if(stats.isDirectory()){
	fs.readdir(jsonDir,(errD,files) => {
	    if(errD) throw errD;
	    console.log(files);
	});
    }
    
});
*/

var resInJson = [];

var allRes = [];

var depth = 0;

var readDir = function ( dirPath ){
    depth++;
    fs.stat(dirPath,(err,stats)=>{
	if(err)throw err;
	if(stats.isDirectory()){
	    fs.readdir( dirPath, (errD, files )=>{
		if(errD)throw errD;
		for(var index in files){
		    if(files[index].indexOf(".") == 0){
			continue;
		    }
		    //console.log(" " + files[index]);
		    readDir( dirPath + "/" + files[index] );
		}
	    });
	}else{
	    if(/\.(json)$/.test(dirPath)){
		readUsedRes( dirPath );
	    }else{
		if( ! ignore(dirPath)){
		    //allRes.push({ "key" : dirPath.slice(dirPath.lastIndexOf("/")), "size":fInspect,});
		    //allRes.push(dirPath.slice(dirPath.lastIndexOf("/")));
		    var name = dirPath.slice(dirPath.lastIndexOf("/"));
		    allRes.push({"key":name,"path": dirPath,});
		}
	    }
	}
	depth--;
	
	diffJson_Res();
	
    });
};



var readUsedRes = function ( jsPath ){
	depth++;
    fs.readFile(jsPath,"utf8",(err, data)=>{
	if(err)throw err;
	if(jsPath.indexOf(".json") == -1){
	    depth--;
	    return;
	}
	
	var jsonArr = JSON.parse(data);
	if( undefined == jsonArr || undefined == jsonArr["Content"] || undefined == jsonArr["Content"]["Content"]){
	    depth--;
	    return;
	}
	var usedRes = jsonArr["Content"]["Content"]["UsedResources"];
	for(var index in usedRes){
	    //console.log("usedRes[index]:" + usedRes[index] + usedRes[index].indexOf(".json"));
	    if(usedRes[index].indexOf(".json") != -1)
		continue;
	    var usedResName = usedRes[index].lastIndexOf("/") == -1 ? usedRes[index] : usedRes[index].slice(usedRes[index].lastIndexOf("/"));
	    resInJson.push(usedResName);
	    //console.log(usedRes[index]);
	}
	
	depth--;

	diffJson_Res();	
    });
};

function diffJson_Res (){
    if(0 == depth){
	console.log(allRes.length);
	//console.log(resInJson);
	for(var idx in allRes){
	    //console.log(allRes[idx]);
	    if(resInJson.indexOf(allRes[idx].key) == -1){
		console.log(allRes[idx].path);
	    }
	}
    }
}

function ignore( str ){
    return ! (/\.(png|plist|jpg)$/.test(str));
}

readDir(jsonDir);


/*

fs.readFile("./testjson.json",'utf8', function(err,data){
    if(err){
	return console.log("readfile error:" + err);
    }
    var jsonArr = JSON.parse(data);
    var usedRes = jsonArr["Content"]["Content"]["UsedResources"];
    var pngList = [];
    for(var index in usedRes){
	if(usedRes[index].indexOf(".png") != -1){
	    pngList.push(usedRes[index]);
	    console.log("usedRes:" + usedRes[index]);
	}
    }
});
*/
