#!/usr/bin
## python diffDirectoryContent src dest [diff/same]
## list [diff/same] content between src and dest

import os
import sys
import shutil

def printList( arr ):
   if( arr == None ):
      return
   for a in arr :
      print(a)

if __name__ == "__main__":
   srcDir = sys.argv[1]
   destDir = sys.argv[2]
   srcNames = os.listdir(srcDir)
   destNames = os.listdir(destDir)
   sameArr = []
   diffSrcArr = []
   diffDestArr = []
   for sName in srcNames:
      hasSame = False
      for dName in destNames:
         if(sName == dName):
            sameArr.append(sName)
            hasSame = True
            break
         else:
            diffDestArr.append(dName)
      if(not hasSame):
         diffSrcArr.append(sName)

   type = 1
   if(len(sys.argv) >= 4):
      type = sys.argv[2]
      
   if(1 == sys.argv[2]):
      print("------------diff content in src  --------")
      printList(diffSrcArr)
      print("------------diff content in dest --------")
      printList(diffDestArr)
   else:
      print("------------same content src_dest -------")
      printList(sameArr)
      ##copy dest file to overwrite src file
   ##print(len(sys.argv))
   if(len(sys.argv) == 5):
      print("copy same file from to dest")
      for f in sameArr:
         os.remove(srcDir + f)
         shutil.copy(destDir + f, srcDir + f)
      
   
   
